/**
 * External dependencies
 */
import {Panel} from '@wordpress/components';
import {useState, useEffect, Fragment} from '@wordpress/element';
import {InspectorControls} from '@wordpress/block-editor';
import {useSelect} from '@wordpress/data';

const addLegalNoticeToCoreImage = (BlockEdit) => {

	return (props) => {

		const [data, setData] = useState(null);

		const fetchedData = useSelect((select) => {
			if ('core/image' === props.name) {
				return select('core').getEntityRecord('postType', 'attachment', props.attributes.id);
			}
		}, [props]);

		useEffect(() => {
			setData(fetchedData);
		}, [fetchedData]);

		if (data?.meta?.chp_legal_notice) {
			props.attributes.className = 'chp-notice-img'
			return (
				<Fragment>
					<BlockEdit {...props} />
					<InspectorControls>
						<div className="chp-warning">
							<Panel>
								<p>This photo has a legal notice. Please contact the picture desk before
									using.
								</p>
							</Panel>
						</div>
					</InspectorControls>
				</Fragment>
			)
		} else {
			return <BlockEdit {...props} />
		}
	};

}

export { addLegalNoticeToCoreImage }
