/**
 * External dependencies
 */
import {useState, useEffect} from '@wordpress/element';
import {useSelect} from '@wordpress/data';

const addLegalNoticeToFeaturedImage = (OriginalComponent) => {

	return (props) => {

		const [data, setData] = useState(null);

		const fetchedData = useSelect((select) => {
			if (props.featuredImageId) {
				return select('core').getEntityRecord('postType', 'attachment', props.featuredImageId);
			}
		}, [props]);

		useEffect(() => {
			setData(fetchedData);
		}, [fetchedData]);

		if (data?.meta?.chp_legal_notice) {
			return (
				<div className="chp-notice-img">
					<OriginalComponent {...props} />
					<div className="chp-warning">
						<p>This photo has a legal notice. Please contact the picture desk before using.</p>
					</div>
				</div>
			)
		} else {
			return (
				<OriginalComponent {...props} />
			)
		}
	}
}

export {addLegalNoticeToFeaturedImage}
